; ==================================================
; = eLiB32 Registry Settings Demo                  =
; = (C) 1999 Teraphy                               =
; =                                                =
; = Demonstrates how to use the Registry Commands  =
; ==================================================

.486
.model		flat, stdcall

; eLiB32 Includes
include		elib32.inc
includelib	elib32.lib
; Windows Includes
include		windows.inc
include		advapi32.inc
includelib	advapi32.lib
include		kernel32.inc
includelib	kernel32.lib
include		user32.inc
includelib	user32.lib

.data

szAppName	db "Reg-Demo",0
szRegName1	db "String",0
szRegName2	db "Value",0

.data?

szBuffer	db 33 dup (?)

.code

Start:

	; Print Message
	PrintM	"eLiB32 Registry Demo", CrLf, \
		"(C) 1999 Teraphy", CrLf, \
		"Enter String: "

	; Read String
	invoke	Input, addr szBuffer, 30

	; Save string to Registry
	inc	eax
	invoke	SaveRegKey, addr szAppName, addr szRegName1, REG_SZ, addr szBuffer, eax

	; Print Message
	PrintM	"Enter Value: "

	; Read String
	invoke	Input, addr szBuffer, 30

	; Convert string to value
	invoke	StrToVal, addr szBuffer, 10

	; Save string to Registry
	mov	dword ptr szBuffer, eax
	invoke	SaveRegKey, addr szAppName, addr szRegName2, REG_DWORD, addr szBuffer, 4

	; Get String from Registry
	invoke	GetRegKey, addr szAppName, addr szRegName1, REG_SZ, addr szBuffer, 32

	; Print String
	PrintFM	<"String: %s">, addr szBuffer

	; Get Value from Registry
	invoke	GetRegKey, addr szAppName, addr szRegName2, REG_DWORD, addr szBuffer, 5

	; Print Value
	PrintFM	<CrLf, "Value: %lu">, dword ptr szBuffer

	; Exit
	Exit	0

end Start
