; ==============================
; === Functions ================
; ==============================

; Input/Output
Print			PROTO	:DWORD
PrintF			PROTO C :DWORD,	:VARARG
Input			PROTO	:DWORD,	:DWORD
GetCLineArg		PROTO	:DWORD,	:DWORD
GetNrOfArgs		PROTO
MsgBoxF			PROTO C	:DWORD,	:DWORD,	:DWORD,	:DWORD,	:VARARG
; String Functions
StrUpr			PROTO	:DWORD,	:DWORD
StrLwr			PROTO	:DWORD,	:DWORD
ReadLine		PROTO	:DWORD, :DWORD, :DWORD
GetNrOfLines		PROTO	:DWORD
; Convert
StrToVal		PROTO	:DWORD,	:DWORD
; Registry
GetRegKey		PROTO	:DWORD,	:DWORD,	:DWORD,	:DWORD,	:DWORD
SaveRegKey		PROTO	:DWORD,	:DWORD,	:DWORD,	:DWORD,	:DWORD
; Hidden APIs
RegisterServiceProcess	PROTO	:DWORD,	:DWORD


; ==============================
; === Macros ===================
; ==============================

PrintM		MACRO sText:VARARG
		LOCAL Temp
.data
	Temp	db sText,0
.code
	invoke	Print, offset Temp
		ENDM

PrintFM		MACRO sText,Args:VARARG
		LOCAL Temp
.data
	Temp	db sText,0
.code
	invoke	PrintF, offset Temp, Args
		ENDM

MBoxM		MACRO Arg1, sText, sTitle, Arg2
		LOCAL Temp
		LOCAL Temp2
.data
	Temp	db sText,0
	Temp2	db sTitle,0
.code
	invoke	MessageBox, Arg1, offset Temp, offset Temp2, Arg2
		ENDM

MBoxFM		MACRO Arg1, sText, Args, sTitle, Arg2
		LOCAL Temp
		LOCAL Temp2
.data
	Temp	db sText,0
	Temp2	db sTitle,0
.code
	invoke	MsgBoxF, Arg1, Arg2, offset Temp2, offset Temp, Args
		ENDM

Exit		MACRO ExitCode
	invoke	ExitProcess, ExitCode
		ENDM


; ==============================
; === Constants ================
; ==============================

; Standard
ERROR		EQU -1
CrLf		EQU <13,10>
; Command Line
CLINE_OK	EQU 0
CLINE_NOTAIL	EQU 1
CLINE_ERRQUOTE	EQU -1
CLINE_NOARG	EQU 3


